"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bootstrapRunner = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const platform_express_1 = require("@nestjs/platform-express");
const tree_1 = require("nx/src/generators/tree");
const project_configuration_1 = require("nx/src/generators/utils/project-configuration");
const app_root_1 = require("nx/src/utils/app-root");
const __runner_module_1 = require("./__runner.module");
function bootstrapRunner(basicFunctionsMap, options = {}) {
    var _a, _b, _c, _d;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const nxTree = new tree_1.FsTree(app_root_1.workspaceRoot, false);
        const projects = (0, project_configuration_1.getProjects)(nxTree);
        const nxEndpoints = [];
        for (const [projectName, module] of basicFunctionsMap) {
            const project = projects.get(projectName);
            if (!project || ((_b = (_a = project === null || project === void 0 ? void 0 : project.targets) === null || _a === void 0 ? void 0 : _a['deploy']) === null || _b === void 0 ? void 0 : _b.executor) !== '@nx-extend/gcp-functions:deploy' || !((_d = (_c = project === null || project === void 0 ? void 0 : project.targets) === null || _c === void 0 ? void 0 : _c['deploy']) === null || _d === void 0 ? void 0 : _d.options)) {
                continue;
            }
            const options = project.targets['deploy'].options;
            let endpoint = `/${options.triggerValue || options.functionName || projectName}`;
            if (options.trigger === 'bucket') {
                endpoint = `/${options.functionName || projectName}`;
            }
            nxEndpoints.push({
                endpoint,
                trigger: options.trigger || 'http',
                func: (yield module)[options.entryPoint]
            });
        }
        const app = yield core_1.NestFactory.create((0, __runner_module_1.createRunnerModule)(nxEndpoints), new platform_express_1.ExpressAdapter(), {
            rawBody: true
        });
        yield app.listen(options.port || 8080, '0.0.0.0').then(() => {
            common_1.Logger.log('Functions running on http://localhost:8080');
        });
    });
}
exports.bootstrapRunner = bootstrapRunner;
//# sourceMappingURL=index.js.map