"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const devkit_1 = require("@nx/devkit");
const path = require("path");
function normalizeOptions(host, options) {
    const name = (0, devkit_1.names)(options.name).fileName;
    const projectDirectory = options.directory
        ? `${(0, devkit_1.names)(options.directory).fileName}/${name}`
        : name;
    const projectName = projectDirectory.replace(new RegExp('/', 'g'), '-');
    const projectRoot = `${(0, devkit_1.getWorkspaceLayout)(host).appsDir}/${projectDirectory}`;
    const parsedTags = options.tags
        ? options.tags.split(',').map((s) => s.trim())
        : [];
    return Object.assign(Object.assign({}, options), { projectName,
        projectRoot,
        projectDirectory,
        parsedTags });
}
function addFiles(host, options) {
    (0, devkit_1.generateFiles)(host, path.join(__dirname, 'files-runner'), options.projectRoot, Object.assign(Object.assign(Object.assign({}, options), (0, devkit_1.names)(options.name)), { offsetFromRoot: (0, devkit_1.offsetFromRoot)(options.projectRoot), template: '' }));
}
function default_1(host, options) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const normalizedOptions = normalizeOptions(host, options);
        (0, devkit_1.addProjectConfiguration)(host, normalizedOptions.projectName, {
            root: normalizedOptions.projectRoot,
            projectType: 'application',
            sourceRoot: `${normalizedOptions.projectRoot}/src`,
            targets: {
                _build: {
                    executor: '@nx/node:build',
                    outputs: ['{options.outputPath}'],
                    options: {
                        outputPath: `dist/${normalizedOptions.projectRoot}`,
                        main: `${normalizedOptions.projectRoot}/src/main.ts`,
                        tsConfig: `${normalizedOptions.projectRoot}/tsconfig.app.json`
                    }
                },
                serve: {
                    executor: '@nx/node:execute',
                    options: {
                        buildTarget: `${normalizedOptions.projectName}:_build`
                    }
                }
            },
            tags: normalizedOptions.parsedTags
        });
        addFiles(host, normalizedOptions);
        yield (0, devkit_1.formatFiles)(host);
    });
}
exports.default = default_1;
//# sourceMappingURL=init.impl.js.map